## esstra 0.2.0

=== Makefile ===
# SPDX-License-Identifier: MIT
# SPDX-FileCopyrightText: Copyright 2024-2025 Sony Group Corporation

PREFIX ?= /usr/local
SUBDIRS := core util

.PHONY: all clean install install-specs uninstall-specs

all install-specs uninstall-specs:
	@make -C core PREFIX=$(PREFIX) $@

install clean:
	@for dir in $(SUBDIRS); do \
	  $(MAKE) -C $$dir PREFIX=$(PREFIX) $@; \
	done

=== core/Makefile ===
# SPDX-FileCopyrightText: Copyright 2024-2025 Sony Group Corporation
# SPDX-License-Identifier: MIT

CXX := g++
PLUGIN_INCLUDE_DIR := $(shell $(CXX) -print-file-name=plugin)
CXXFLAGS += -Wall -Wextra
CXXFLAGS += -I$(PLUGIN_INCLUDE_DIR)/include -fPIC -fno-rtti -O2 -std=c++17
GCC_MAJOR_VERSION := $(shell $(CXX) -dumpversion)
GCC_ARCH := $(shell $(CXX) -dumpmachine)

ESSTRACORE_SOURCES := esstracore.cpp
ESSTRACORE := $(ESSTRACORE_SOURCES:.cpp=.so)

# hash functions
THIRD_PARTY_DIR = ../third-party
WJCRYPTLIB_DIR := $(THIRD_PARTY_DIR)/WjCryptLib/lib
WJCRYPTLIB_FILES := \
	$(WJCRYPTLIB_DIR)/WjCryptLib_Md5.c \
	$(WJCRYPTLIB_DIR)/WjCryptLib_Sha1.c \
	$(WJCRYPTLIB_DIR)/WjCryptLib_Sha256.c
ESSTRACORE_SOURCES += $(WJCRYPTLIB_FILES)
CXXFLAGS += -I $(WJCRYPTLIB_DIR)

PREFIX ?= /usr/local
INSTALLDIR := $(DESTDIR)/$(PREFIX)/lib/gcc/$(GCC_ARCH)/$(GCC_MAJOR_VERSION)/plugin
INSTALLDIR := $(subst //,/,$(INSTALLDIR))

SPECFILE := $(shell dirname `gcc -print-libgcc-file-name`)/specs

.PHONY: all clean install install-specs uninstall-specs

all: $(ESSTRACORE)

$(WJCRYPTLIB_FILES):
	(cd $(THIRD_PARTY_DIR) && git submodule init && git submodule update)

$(ESSTRACORE): $(ESSTRACORE_SOURCES)
	$(CXX) -shared $(CXXFLAGS) $^ -o $@

install: $(ESSTRACORE)
	install -m 755 -d $(INSTALLDIR)
	install -m 755 $(ESSTRACORE) $(INSTALLDIR)

clean:
	rm -f *.so

install-specs: $(INSTALLDIR)/$(ESSTRACORE)
	gcc -dumpspecs | \
	sed -E "N;s|\*cc1:\n(.+)$$|*cc1:\n\1 %{!fplugin:-fplugin=$(INSTALLDIR)/$(ESSTRACORE)}|" \
	> $(SPECFILE)

uninstall-specs: $(SPECFILE)
	rm -f $(SPECFILE)

=== util/Makefile ===
# SPDX-FileCopyrightText: Copyright 2024-2025 Sony Group Corporation
# SPDX-License-Identifier: MIT

PREFIX ?= /usr/local
INSTALLDIR := $(DESTDIR)/$(PREFIX)/bin
INSTALLDIR := $(subst //,/,$(INSTALLDIR))
ESSTRAUTIL := esstra.py

.PHONY: all clean install

all clean:
	@echo do nothing for target: "$@"

install: $(ESSTRAUTIL)
	install -m 755 -d $(INSTALLDIR)
	install -m 755 $(ESSTRAUTIL) $(INSTALLDIR)

=== samples/hello/Makefile ===
# SPDX-FileCopyrightText: Copyright 2024-2025 Sony Group Corporation
# SPDX-License-Identifier: MIT

CC := gcc
GCC_MAJOR_VERSION := $(shell $(CXX) -dumpversion)
GCC_ARCH := $(shell $(CXX) -dumpmachine)

PREFIX ?= /usr/local
GCC_PLUGIN_DIR := $(DESTDIR)/$(PREFIX)/lib/gcc/$(GCC_ARCH)/$(GCC_MAJOR_VERSION)/plugin
GCC_PLUGIN_DIR := $(subst //,/,$(GCC_PLUGIN_DIR))
ESSTRACORE ?= $(GCC_PLUGIN_DIR)/esstracore.so
ESSTRACORE := $(subst //,/,$(ESSTRACORE))

ifdef DEBUG
DEBUGFLAG := -fplugin-arg-esstracore-debug=$(DEBUG)
endif

CFLAGS += -fplugin=$(ESSTRACORE) $(DEBUGFLAG) -O2 -Wall

.PHONY: all clean

all: hello

hello: hello.c
	$(CC) $(CFLAGS) $< -o hello

clean:
	rm -f hello *.bak

=== samples/hello2/Makefile ===
# SPDX-FileCopyrightText: Copyright 2024-2025 Sony Group Corporation
# SPDX-License-Identifier: MIT

CC := gcc
GCC_MAJOR_VERSION := $(shell $(CXX) -dumpversion)
GCC_ARCH := $(shell $(CXX) -dumpmachine)

PREFIX ?= /usr/local
GCC_PLUGIN_DIR := $(DESTDIR)/$(PREFIX)/lib/gcc/$(GCC_ARCH)/$(GCC_MAJOR_VERSION)/plugin
GCC_PLUGIN_DIR := $(subst //,/,$(GCC_PLUGIN_DIR))
ESSTRACORE ?= $(GCC_PLUGIN_DIR)/esstracore.so

ifdef DEBUG
DEBUGFLAG := -fplugin-arg-esstracore-debug=$(DEBUG)
endif

CFLAGS += -fplugin=$(ESSTRACORE) $(DEBUGFLAG) -O2 -Wall

SOURCES := hello_main.c hello_sub.c
TARGET := hello2

.PHONY: all clean

all: $(TARGET)

$(TARGET): $(SOURCES)
	$(CC) $(CFLAGS) $^ -o $@

clean:
	rm -f $(TARGET) *.o *.bak

=== debian/changelog ===
esstra (0.2.0-3) unstable; urgency=medium

  * Add debian/patches/LDFLAGS.patch for hardening
  * Generate esstra manpage
    - Add debian/clean and debian/esstra.manpages
    - Add help2man to debian/control
    - Update debian/rules to generate manpage

 -- Hideki Yamane <henrich@debian.org>  Thu, 31 Jul 2025 15:09:16 +0900

esstra (0.2.0-2) unstable; urgency=medium

  * debian/patches
    - Update patches: Add DEP3 metadata
  * debian/watch
    - Fix it to work

 -- Hideki Yamane <henrich@debian.org>  Tue, 15 Jul 2025 17:59:40 +0200

esstra (0.2.0-1) unstable; urgency=medium

  * New upstream release during DebConf25! :)

  * Upload to unstable
  * debian/patches
    - Drop destdir.patch: merged upstream
    - Refresh strip_extention.patch

 -- Hideki Yamane <henrich@debian.org>  Mon, 14 Jul 2025 09:22:38 +0200

esstra (0.1.0-1) experimental; urgency=medium

  * Initial release. (Closes: #1104228)

 -- Hideki Yamane <henrich@debian.org>  Mon, 19 May 2025 05:50:07 +0900

=== debian/control ===
Source: esstra
Section: devel
Priority: optional
Maintainer: Hideki Yamane <henrich@debian.org>
Rules-Requires-Root: no
Build-Depends:
 help2man, python3-yaml,
 debhelper-compat (= 13),
 gcc-14-plugin-dev,
#TODO: update GCC version semi-automatically
Standards-Version: 4.7.2
Homepage: https://github.com/sony/esstra
Vcs-Browser: https://salsa.debian.org/debian/esstra
Vcs-Git: https://salsa.debian.org/debian/esstra.git

Package: esstra
Architecture: any
Depends:
 python3, python3-yaml,
 ${shlibs:Depends},
 ${misc:Depends},
Description: software suite for Enhancing Software Supply Chain Transparency
 esstra, software suite for Enhancing Software Supply Chain Transparency, aims
 to improve transparency of software supply chains as the name suggests.
 .
 It embeds metadata in resulting binary files at compile time, contains
 information about the source and header files from which the binary file is
 generated.

=== debian/rules ===
#!/usr/bin/make -f

# See FEATURE AREAS in dpkg-buildflags(1).
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# See ENVIRONMENT in dpkg-buildflags(1).
# Package maintainers to append CFLAGS.
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# Package maintainers to append LDFLAGS.
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export PREFIX=/usr

%:
	dh $@

debian/esstra.1:
	help2man -n "Utility for accessing metadata in binary files embedded by the ESSTRA Core" \
		"$(CURDIR)/util/esstra.py -h" > $@

override_dh_installman: debian/esstra.1
	dh_installman

## esstra 0.3.0

=== Makefile ===
# SPDX-License-Identifier: MIT
# SPDX-FileCopyrightText: Copyright 2024-2025 Sony Group Corporation

PREFIX ?= /usr/local
SUBDIRS := core util

.PHONY: all clean install install-specs uninstall-specs uninstall-core uninstall

all install-specs uninstall-specs uninstall-core:
	@make -C core PREFIX=$(PREFIX) $@

install clean uninstall:
	@for dir in $(SUBDIRS); do \
	  $(MAKE) -C $$dir PREFIX=$(PREFIX) $@; \
	done

=== core/Makefile ===
--- 
+++ 
@@ -27,7 +27,7 @@
 
 SPECFILE := $(shell dirname `gcc -print-libgcc-file-name`)/specs
 
-.PHONY: all clean install install-specs uninstall-specs
+.PHONY: all clean install install-specs uninstall-specs uninstall-core uninstall
 
 all: $(ESSTRACORE)
 
@@ -35,7 +35,7 @@
 	(cd $(THIRD_PARTY_DIR) && git submodule init && git submodule update)
 
 $(ESSTRACORE): $(ESSTRACORE_SOURCES)
-	$(CXX) -shared $(CXXFLAGS) $^ -o $@
+	$(CXX) -shared $(CXXFLAGS) $(CPPFLAGS) $(LDFLAGS) $^ -o $@
 
 install: $(ESSTRACORE)
 	install -m 755 -d $(INSTALLDIR)
@@ -51,3 +51,8 @@
 
 uninstall-specs: $(SPECFILE)
 	rm -f $(SPECFILE)
+
+uninstall-core:
+	rm -f $(INSTALLDIR)/$(ESSTRACORE)
+
+uninstall: uninstall-core uninstall-specs

=== util/Makefile ===
# SPDX-FileCopyrightText: Copyright 2024-2025 Sony Group Corporation
# SPDX-License-Identifier: MIT

PREFIX ?= /usr/local
INSTALLDIR := $(DESTDIR)/$(PREFIX)/bin
INSTALLDIR := $(subst //,/,$(INSTALLDIR))
ESSTRAUTIL := esstra

.PHONY: all clean install uninstall

all clean:
	@echo do nothing for target: "$@"

install: $(ESSTRAUTIL)
	install -m 755 -d $(INSTALLDIR)
	install -m 755 $(ESSTRAUTIL) $(INSTALLDIR)

uninstall:
	rm -f $(INSTALLDIR)/$(ESSTRAUTIL)

=== samples/hello/Makefile ===
--- 
+++ 
@@ -2,8 +2,8 @@
 # SPDX-License-Identifier: MIT
 
 CC := gcc
-GCC_MAJOR_VERSION := $(shell $(CXX) -dumpversion)
-GCC_ARCH := $(shell $(CXX) -dumpmachine)
+GCC_MAJOR_VERSION := $(shell $(CC) -dumpversion)
+GCC_ARCH := $(shell $(CC) -dumpmachine)
 
 PREFIX ?= /usr/local
 GCC_PLUGIN_DIR := $(DESTDIR)/$(PREFIX)/lib/gcc/$(GCC_ARCH)/$(GCC_MAJOR_VERSION)/plugin

=== samples/hello2/Makefile ===
--- 
+++ 
@@ -2,8 +2,8 @@
 # SPDX-License-Identifier: MIT
 
 CC := gcc
-GCC_MAJOR_VERSION := $(shell $(CXX) -dumpversion)
-GCC_ARCH := $(shell $(CXX) -dumpmachine)
+GCC_MAJOR_VERSION := $(shell $(CC) -dumpversion)
+GCC_ARCH := $(shell $(CC) -dumpmachine)
 
 PREFIX ?= /usr/local
 GCC_PLUGIN_DIR := $(DESTDIR)/$(PREFIX)/lib/gcc/$(GCC_ARCH)/$(GCC_MAJOR_VERSION)/plugin

=== debian/changelog ===
esstra (0.3.0-3) unstable; urgency=medium

  * Wrong previous upload, rebuild it and put it properly now...
    (Closes: #1114032)

 -- Hideki Yamane <henrich@debian.org>  Sun, 07 Sep 2025 13:56:11 +0900

esstra (0.3.0-2) unstable; urgency=medium

  * debian/{control,rules}
    - Set dependencies to rebuild with gcc-15, since "gcc" package pulls
      gcc-15 now.

 -- Hideki Yamane <henrich@debian.org>  Thu, 04 Sep 2025 21:58:00 +0900

esstra (0.3.0-1) unstable; urgency=medium

  * New upstream release

  * debian/patches
    - Drop some debian/patches files, merged upstream
  * debian/rules
    - Call explicitly python3 for esstra for help2man

 -- Hideki Yamane <henrich@debian.org>  Mon, 01 Sep 2025 16:23:01 +0900

esstra (0.2.0-6) unstable; urgency=medium

  * Add debian/patches/set-path-max.patch to fix build failure on hurd

 -- Hideki Yamane <henrich@debian.org>  Wed, 27 Aug 2025 19:27:45 +0900

esstra (0.2.0-5) unstable; urgency=medium

  * debian/{control,rules}
    - Add dependencies to cc or cpp
    - Avoid incompatibility during GCC minor version changes

 -- Hideki Yamane <henrich@debian.org>  Sun, 24 Aug 2025 22:20:44 +0900

esstra (0.2.0-4) unstable; urgency=medium

  * debian/rules
    - Fix help2man with esstra(.py)
  * debian/patches
    - hardening.patch
      + Drop unnecessary CFLAGS
      + Forwarded to upstream issue
    - Use-gcc-for-sample.patch
      + Add it
  * debian/tests
    - Add autopkgtest

 -- Hideki Yamane <henrich@debian.org>  Sun, 03 Aug 2025 23:07:34 +0900

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Build-Depends:
  help2man, python3-yaml,
  debhelper-compat (= 13),
- gcc-14-plugin-dev,
+ gcc-15-plugin-dev,
 #TODO: update GCC version semi-automatically
 Standards-Version: 4.7.2
 Homepage: https://github.com/sony/esstra
@@ -19,6 +19,8 @@
  python3, python3-yaml,
  ${shlibs:Depends},
  ${misc:Depends},
+# GCC does not guarantee its internal ABI/API compatibilities, so specify its versions.
+ gcc-15-base (= ${gccFullVersion}), gcc-15 | g++-15,
 Description: software suite for Enhancing Software Supply Chain Transparency
  esstra, software suite for Enhancing Software Supply Chain Transparency, aims
  to improve transparency of software supply chains as the name suggests.

=== debian/rules ===
--- 
+++ 
@@ -16,7 +16,12 @@
 
 debian/esstra.1:
 	help2man -n "Utility for accessing metadata in binary files embedded by the ESSTRA Core" \
-		"$(CURDIR)/util/esstra.py -h" > $@
+	--no-info "python3 $(CURDIR)/util/esstra" > $@
 
 override_dh_installman: debian/esstra.1
 	dh_installman
+
+override_dh_gencontrol:
+	echo "gccFullVersion=$(shell dpkg-query --showformat='$${Version}' --show gcc-15-base)" \
+		>> debian/esstra.substvars
+	dh_gencontrol

=== debian/tests/control ===
Tests: esstra-embed-metadata
Depends: @, make, libc6-dev, gcc
